-------------------------------------------------------------------------------
-- ElvUI Raid Markers Datatext By Lockslap
-- <Borderline Amazing> US, Bleeding Hollow
-------------------------------------------------------------------------------
local E, L, V, P, G, _ = unpack(ElvUI)
local RM = E:NewModule("RaidMarkers")
local M = E:GetModule("Minimap")

local BUTTON_HEIGHT = 18
local BUTTON_WIDTH = 18
local BUTTON_DISTANCE = 5
local FRAME_HEIGHT = 22
local FRAME_WIDTH = 150

P["raidmarkers"] = {
	["show"] = true,
}

SlashCmdList["ELVRAIDMARKERS"] = function(msg, editbox)
	E.db.raidmarkers.show = not E.db.raidmarkers.show
	if E.db.raidmarkers.show then
		ElvRMFrame:Show()
	else
		ElvRMFrame:Hide()
	end
end
SLASH_ELVRAIDMARKERS1 = "/erm"

local function UpdateBar()
	local cToggle = ElvConfigToggle:GetWidth() or 0
	FRAME_WIDTH = Minimap:GetWidth() + cToggle + 1
	BUTTON_DISTANCE = math.ceil((FRAME_WIDTH - (BUTTON_WIDTH * 9)) / 9)
	_G["ElvRMFrame"]:SetWidth(FRAME_WIDTH)
	_G["ElvRMFrame"]:ClearAllPoints()
	_G["ElvRMFrame"]:SetPoint("TOPLEFT", LeftMiniPanel:IsShown() and LeftMiniPanel or Minimap, "BOTTOMLEFT", LeftMiniPanel:IsShown() and 0 or -1, 1)
	for i = 1, 9 do
		local button = _G[("ElvRMFrameButton%d"):format(i)]
		local prev = _G[("ElvRMFrameButton%d"):format(i - 1)]
		button:ClearAllPoints()
		if i == 1 then
			button:SetPoint("LEFT", 3, 0)
		else
			button:SetPoint("LEFT", prev, "RIGHT", BUTTON_DISTANCE, 0)
		end
	end
end

function RM:Initialize()
	-- figure out the distance between the icons
	local cToggle = ElvConfigToggle:GetWidth() or 0
	FRAME_WIDTH = Minimap:GetWidth() + cToggle + 1
	BUTTON_DISTANCE = math.ceil((FRAME_WIDTH - (BUTTON_WIDTH * 9)) / 9)
	
	local f = CreateFrame("Frame", "ElvRMFrame", E.UIParent)
	f:SetResizable(false)
	f:SetHeight(FRAME_HEIGHT)
	f:SetWidth(FRAME_WIDTH)
	f:SetTemplate("Default", true)
	f:SetPoint("TOPLEFT", LeftMiniPanel:IsShown() and LeftMiniPanel or Minimap, "BOTTOMLEFT", LeftMiniPanel:IsShown() and 0 or -1, 1)
	
	-- create the buttons
	for i = 1, 8 do
		local button = CreateFrame("Button", ("ElvRMFrameButton%d"):format(i), f)
		button:EnableMouse(true)
		button:SetHeight(BUTTON_HEIGHT)
		button:SetWidth(BUTTON_WIDTH)
		button:SetScript("OnClick", function(self, button)
			if GetRaidTargetIndex("target") ~= i then
				SetRaidTarget("target", i)
			else
				SetRaidTarget("target", 0)
			end
		end)
		
		if i == 1 then
			button:SetPoint("LEFT", 3, 0)
		else
			local prev = _G[("ElvRMFrameButton%d"):format(i - 1)]
			button:SetPoint("LEFT", prev, "RIGHT", BUTTON_DISTANCE, 0)
		end
		
		local image = button:CreateTexture(nil, "BACKGROUND")
		image:SetAllPoints()
		image:SetTexture(("Interface\\TargetingFrame\\UI-RaidTargetingIcon_%d"):format(i))
		
		local highlight = button:CreateTexture(nil, "HIGHLIGHT")
		highlight:SetAllPoints(image)
		highlight:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-Tab-Highlight")
		highlight:SetTexCoord(0, 1, 0.23, 0.77)
		highlight:SetBlendMode("ADD")
	end
	
	-- remove button
	local cancel = CreateFrame("Button", "ElvRMFrameButton9", f)
	cancel:EnableMouse(true)
	cancel:SetHeight(BUTTON_HEIGHT)
	cancel:SetWidth(BUTTON_WIDTH)
	cancel:SetPoint("LEFT", _G["ElvRMFrameButton8"], "RIGHT", BUTTON_DISTANCE, 0)
	cancel:SetScript("OnClick", function(self, button) SetRaidTarget("target", 0) end)
	
	local cImage = cancel:CreateTexture(nil, "BACKGROUND")
	cImage:SetAllPoints()
	cImage:SetTexture("Interface\\BUTTONS\\UI-GroupLoot-Pass-Up")
	
	local cHighlight = cancel:CreateTexture(nil, "HIGHLIGHT")
	cHighlight:SetAllPoints(cImage)
	cHighlight:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-Tab-Highlight")
	cHighlight:SetTexCoord(0, 1, 0.23, 0.77)
	cHighlight:SetBlendMode("ADD")
	
	hooksecurefunc(M, "UpdateSettings", UpdateBar)
	
	if E.db.raidmarkers.show then
		f:Show()
	else
		f:Hide()
	end
end

E:RegisterModule(RM:GetName())